import { isImmutable, modify, commit } from '@collectable/core';
import { iterate, unsetItem } from '../internals';
import { size } from './size';
export function filter(fn, map) {
    var nextSet = modify(map);
    var keyMap = nextSet._indexed;
    var sortedValues = nextSet._sorted;
    var it = iterate(map);
    var current;
    var index = 0, remaining = size(map);
    while (!(current = it.next()).done) {
        var entry = current.value;
        const key = entry.key.key;
        if (!fn(entry.value, key, index++)) {
            remaining--;
            unsetItem(key, keyMap, sortedValues);
        }
    }
    if (remaining <= 0) {
        return map;
    }
    commit(nextSet);
    if (isImmutable(map)) {
        return nextSet;
    }
    map._indexed = keyMap;
    map._sorted = sortedValues;
    return map;
}

//# sourceMappingURL=filter.js.map
