import { isImmutable, commit } from '@collectable/core';
import { cloneSortedMap } from '../internals';
import { iterate, setItem } from '../internals';
export function map(fn, map) {
    var nextMap = cloneSortedMap(map, true, true);
    var keyMap = nextMap._indexed;
    var sortedValues = nextMap._sorted;
    var select = nextMap._select;
    var it = iterate(map);
    var current;
    var index = 0;
    while (!(current = it.next()).done) {
        var value = current.value;
        const key = value.key.key;
        setItem(key, fn(value.value, key, index++), keyMap, sortedValues, select);
    }
    commit(nextMap);
    if (isImmutable(map)) {
        return nextMap;
    }
    map._indexed = keyMap;
    map._sorted = sortedValues;
    return map;
}

//# sourceMappingURL=map.js.map
