import { modify, commit } from '@collectable/core';
import { remove, get, set } from './index';
export function updateMap(callback, map) {
    var nextMap = modify(map);
    nextMap = callback(nextMap) || nextMap;
    return commit(nextMap);
}
export function update(callback, key, map) {
    var oldv = get(key, map);
    var newv = callback(oldv, map);
    return newv === oldv ? map
        : newv === void 0 ? remove(key, map)
            : set(key, newv, map);
}

//# sourceMappingURL=update.js.map
